Bug 1293725 - UEFI bootloader is not updated by rpm-ostree, even though rpm package version suggests otherwise
UEFI bootloader is not updated by rpm-ostree, even though rpm package version...
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: rpm-ostree (Show other bugs)
26
Unspecified Unspecified
low Severity unspecified
: ---
: ---
Assigned To: Colin Walters
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-22 15:58 EST by Chris Murphy
Modified: 2017-02-28 04:51 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Chris Murphy 2015-12-22 15:58:36 EST
Description of problem:

On a UEFI system, /boot/efi/EFI/fedora/grubx64.efi is not updated by 'rpm-ostree upgrade' even though the grub2-efi package version is updated.


Version-Release number of selected component (if applicable):
rpm-ostree-2015.11-1.fc23.x86_64
ostree-2015.11-2.fc23.x86_64


How reproducible:
Always

Steps to Reproduce:
1. rpm-ostree upgrade
2. reboot
3.

Actual results:

System is now on 23.38 and rpm -q reports grub2-efi-2.02-0.25.fc23.x86_64.

However, sha256sum of /boot/efi/EFI/fedora/grubx64.efi matches that of the grubx64.efi binary in grub2-efi-2.02-0.23.fc23.x86_64.rpm


Expected results:

grubx64.efi should be the binary in the package reported to be installed.


Additional info:

https://lists.fedoraproject.org/archives/list/cloud%40lists.fedoraproject.org/thread/JUTQBMUSO25WRAWTFLTMODM2MUBEF2RR/
Comment 1 Colin Walters 2015-12-22 16:54:43 EST
This is currently expected; there are no %post scripts per package on the client, they're all run on the compose server.  extlinux used to update itself in %post but that was backed out.

Bootloaders for rpm-ostree are thus installed exactly once by Anaconda right now.

Offhand I'd say that it'd be best if Fedora had a once-per-major-version upgrade model for the bootloader.  This could be a systemd service, or generally something shared by the fedup code and rpm-ostree.
Comment 2 Chris Murphy 2015-12-22 23:19:47 EST
Short term fix proposal: How about rpm -q spits back grub2-efi-2.02-0.23.fc23.x86_64.rpm? i.e. pin the version of the RPM so that it actually matches the version of the EFI bootloader binaries on the ESP? At least that way I'm not mislead by the reported version number into thinking I've got the 0.25 fix for CVE-2015-8370.

I don't think it's realistic to have a once per major version upgrade model. The updates aren't arbitrary, they happen when they happen, and we have to have a way for atomic baremetal installs to be as secure and up to date as non-atomic baremetal installs - eventually.
Comment 3 Chris Murphy 2015-12-23 14:57:23 EST
For example, grub2-2.02-0.7.fc22 is the first instance of GRUB for Fedora 22, and the current one is grub2-2.02-0.18.fc22. In that time frame, CVE-2014-4607 and CVE-2015-8370 were fixed, as were a bunch of bugs. On average it looks like each release sees GRUB updated about 10 times.

I see this bug as a kind of regression from UEFI non-atomic installs, back to the broken state on BIOS, except worse because grub2-install isn't available on UEFI. The user has to know to copy /usr/lib/ostree-boot/efi/EFI/fedora/grubx64.efi to the ESP to actually update the bootloader.
Comment 4 Colin Walters 2016-01-04 11:41:46 EST
I agree this is a problem that we need to fix, but it's also not new to Atomic; *non*-UEFI *non* Atomic, i.e. BIOS "mainline" installs also don't have the bootloader updated by RPM updates either.
Comment 5 Colin Walters 2016-01-27 09:46:47 EST
Unlikely to design a solution here soon, but keeping the bug open.
Comment 6 Fedora End Of Life 2016-11-24 09:27:54 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 7 Fedora End Of Life 2017-02-28 04:51:52 EST
This bug appears to have been reported against 'rawhide' during the Fedora 26 development cycle.
Changing version to '26'.

Note You need to log in before you can comment on or make changes to this bug.